Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.servlet.jsp
Class PageContext

    java.lang.Object
      |
      +--javax.servlet.jsp.PageContext

public abstract class PageContext
extends java.lang.Object

A PageContext instance provides access to all the namespaces associated with a JSP page, provides access to several page attributes, as well as a layer above the implementation details. Implicit objects are added the pageContext automatically.

The `PageContext` class is an abstract class, designed to be extended to provide implementation dependent implementations thereof, by conformant JSP engine runtime environments. A PageContext instance is obtained by a JSP implementation class by calling the JspFactory.getPageContext() method, and is released by calling JspFactory.releasePageContext().

An example of how PageContext, JspFactory, and other classes can be used within a JSP Page Implementation object is given elsewhere.

The PageContext provides a number of facilities to the page/component author and page implementor, including:

- a single API to manage the various scoped namespaces
- a number of convenience API's to access various public objects
- a mechanism to obtain the JspWriter for output
- a mechanism to manage session usage by the page
- a mechanism to expose page directive attributes to the scripting environment
- mechanisms to forward or include the current request to other active components in the application
- a mechanism to handle errorpage exception processing

Methods Intended for Container Generated Code

Some methods are intended to be used by the code generated by the container, not by code written by JSP page authors, or JSP tag library authors.

The methods supporting lifecycle are `initialize()` and `release()`

The following methods enable the management of nested JspWriter streams to implement Tag Extensions: `pushBody()` and `popBody()`

Methods Intended for JSP authors

Some methods provide uniform access to the diverse objects representing scopes. The implementation must use the underlying Servlet machinery corresponding to that scope, so information can be passed back and forth between Servlets and JSP pages. The methods are: `setAttribute()`, `getAttribute()`, `findAttribute()`, `removeAttribute()`, `getAttributesScope()` and `getAttributeNamesInScope()` .

The following methods provide convenient access to implicit objects:

`getOut()`, `getException()`, `getPage()` `getRequest()`, `getResponse()`, `getSession()`, `getServletConfig()` and `getServletContext()`.

The following methods provide support for forwarding, inclusion and error handling: `forward()`, `include()`, and `handlePageException()`.

Field Summary
`static java.lang.String` | `APPLICATION` Name used to store ServletContext in PageContext name table.
`static int` | `APPLICATION_SCOPE` Application scope: named reference remains available in the ServletContext until it is reclaimed.
`static java.lang.String` | `CONFIG` Name used to store ServletConfig in PageContext name table.
`static java.lang.String` | `EXCEPTION` Name used to store uncaught exception in ServletRequest attribute list and PageContext name table.
`static java.lang.String` | `OUT` Name used to store current JspWriter in PageContext name table.
`static java.lang.String` | `PAGE` Name used to store the Servlet in this PageContext's nametables.
`static int` | `PAGE_SCOPE` Page scope: (this is the default) the named reference remains available in this PageContext until the return from the current Servlet.service() invocation.
`static java.lang.String` | `PAGECONTEXT` Name used to store this PageContext in it's own name table.
`static java.lang.String` | `REQUEST` Name used to store ServletRequest in PageContext name table.
`static int` | `REQUEST_SCOPE` Request scope: the named reference remains available from the ServletRequest associated with the Servlet until the current request is completed.
`static java.lang.String` | `RESPONSE` Name used to store ServletResponse in PageContext name table.
`static java.lang.String` | `SESSION` Name used to store HttpSession in PageContext name table.
`static int` | `SESSION_SCOPE` Session scope (only valid if this page participates in a session): the named reference remains available from the HttpSession (if any) associated with the Servlet until the HttpSession is invalidated.

Constructor Summary
`PageContext()`

Method Summary
`abstract java.lang.Object` | `findAttribute(java.lang.String name)` Searches for the named attribute in page, request, session (if valid), and application scope(s) in order and returns the value associated or null.
`abstract void` | `forward(java.lang.String relativeUrlPath)` This method is used to re-direct, or "forward" the current ServletRequest and ServletResponse to another active component in the application.
`abstract java.lang.Object` | `getAttribute(java.lang.String name)` Return the object associated with the name in the page scope or null if not found.
`abstract java.lang.Object` | `getAttribute(java.lang.String name, int scope)` Return the object associated with the name in the specified scope or null if not found.
`abstract java.util.Enumeration` | `getAttributeNamesInScope(int scope)` Enumerate all the attributes in a given scope
`abstract int` | `getAttributesScope(java.lang.String name)` Get the scope where a given attribute is defined.
`abstract java.lang.Exception` | `getException()` The current value of the exception object (an Exception).
`abstract JspWriter` | `getOut()` The current value of the out object (a JspWriter).
`abstract java.lang.Object` | `getPage()` The current value of the page object (a Servlet).
`abstract ServletRequest` | `getRequest()` The current value of the request object (a ServletRequest).
`abstract ServletResponse` | `getResponse()` The current value of the response object (a ServletResponse).
`abstract ServletConfig` | `getServletConfig()` The ServletConfig instance.
`abstract ServletContext` | `getServletContext()` The ServletContext instance.
`abstract HttpSession` | `getSession()` The current value of the session object (an HttpSession).
`abstract void` | `handlePageException(java.lang.Exception e)` This method is intended to process an unhandled "page" level exception by redirecting the exception to either the specified error page for this JSP, or if none was specified, to perform some implementation dependent action.
`abstract void` | `handlePageException(java.lang.Throwable t)` This method is identical to the handlePageException(Exception), except that it accepts a Throwable.
`abstract void` | `include(java.lang.String relativeUrlPath)` Causes the resource specified to be processed as part of the current ServletRequest and ServletResponse being processed by the calling Thread.
`abstract void` | `initialize(Servlet servlet, ServletRequest request, ServletResponse response, java.lang.String errorPageURL, boolean needsSession, int bufferSize, boolean autoFlush)` The initialize method is called to initialize an uninitialized PageContext so that it may be used by a JSP Implementation class to service an incoming request and response within it's _jspService() method.
`JspWriter` | `popBody()` Return the previous JspWriter "out" saved by the matching pushBody(), and update the value of the "out" attribute in the page scope attribute namespace of the PageConxtext
`BodyContent` | `pushBody()` Return a new BodyContent object, save the current "out" JspWriter, and update the value of the "out" attribute in the page scope attribute namespace of the PageContext
`abstract void` | `release()` This method shall "reset" the internal state of a PageContext, releasing all internal references, and preparing the PageContext for potential reuse by a later invocation of initialize().
`abstract void` | `removeAttribute(java.lang.String name)` Remove the object reference associated with the given name, look in all scopes in the scope order.
`abstract void` | `removeAttribute(java.lang.String name, int scope)` Remove the object reference associated with the specified name in the given scope.
`abstract void` | `setAttribute(java.lang.String name, java.lang.Object attribute)` Register the name and object specified with page scope semantics.
`abstract void` | `setAttribute(java.lang.String name, java.lang.Object o, int scope)` register the name and object specified with appropriate scope semantics

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### PAGE_SCOPE

    public static final int PAGE_SCOPE

  Page scope: (this is the default) the named reference remains available in this PageContext until the return from the current Servlet.service() invocation.

  See Also:
    Constant Field Values

### REQUEST_SCOPE

    public static final int REQUEST_SCOPE

  Request scope: the named reference remains available from the ServletRequest associated with the Servlet until the current request is completed.

  See Also:
    Constant Field Values

### SESSION_SCOPE

    public static final int SESSION_SCOPE

  Session scope (only valid if this page participates in a session): the named reference remains available from the HttpSession (if any) associated with the Servlet until the HttpSession is invalidated.

  See Also:
    Constant Field Values

### APPLICATION_SCOPE

    public static final int APPLICATION_SCOPE

  Application scope: named reference remains available in the ServletContext until it is reclaimed.

  See Also:
    Constant Field Values

### PAGE

    public static final java.lang.String PAGE

  Name used to store the Servlet in this PageContext's nametables.

  See Also:
    Constant Field Values

### PAGECONTEXT

    public static final java.lang.String PAGECONTEXT

  Name used to store this PageContext in it's own name table.

  See Also:
    Constant Field Values

### REQUEST

    public static final java.lang.String REQUEST

  Name used to store ServletRequest in PageContext name table.

  See Also:
    Constant Field Values

### RESPONSE

    public static final java.lang.String RESPONSE

  Name used to store ServletResponse in PageContext name table.

  See Also:
    Constant Field Values

### CONFIG

    public static final java.lang.String CONFIG

  Name used to store ServletConfig in PageContext name table.

  See Also:
    Constant Field Values

### SESSION

    public static final java.lang.String SESSION

  Name used to store HttpSession in PageContext name table.

  See Also:
    Constant Field Values

### OUT

    public static final java.lang.String OUT

  Name used to store current JspWriter in PageContext name table.

  See Also:
    Constant Field Values

### APPLICATION

    public static final java.lang.String APPLICATION

  Name used to store ServletContext in PageContext name table.

  See Also:
    Constant Field Values

### EXCEPTION

    public static final java.lang.String EXCEPTION

  Name used to store uncaught exception in ServletRequest attribute list and PageContext name table.

  See Also:
    Constant Field Values

Constructor Detail

### PageContext

    public PageContext()

Method Detail

### initialize

    public abstract void initialize(Servlet servlet,
                                    ServletRequest request,
                                    ServletResponse response,
                                    java.lang.String errorPageURL,
                                    boolean needsSession,
                                    int bufferSize,
                                    boolean autoFlush)
                             throws java.io.IOException,
                                    java.lang.IllegalStateException,
                                    java.lang.IllegalArgumentException

  The initialize method is called to initialize an uninitialized PageContext so that it may be used by a JSP Implementation class to service an incoming request and response within it's _jspService() method.

  This method is typically called from JspFactory.getPageContext() in order to initialize state.

  This method is required to create an initial JspWriter, and associate the "out" name in page scope with this newly created object.

  This method should not be used by page or tag library authors.

  Parameters:
    `servlet` - The Servlet that is associated with this PageContext
    `request` - The currently pending request for this Servlet
    `response` - The currently pending response for this Servlet
    `errorPageURL` - The value of the errorpage attribute from the page directive or null
    `needsSession` - The value of the session attribute from the page directive
    `bufferSize` - The value of the buffer attribute from the page directive
    `autoFlush` - The value of the autoflush attribute from the page directive
  Throws:
    `java.io.IOException` - during creation of JspWriter
    `java.lang.IllegalStateException` - if out not correctly initialized
    `java.lang.IllegalArgumentException`

### release

    public abstract void release()

  This method shall "reset" the internal state of a PageContext, releasing all internal references, and preparing the PageContext for potential reuse by a later invocation of initialize(). This method is typically called from JspFactory.releasePageContext().

  Subclasses shall envelope this method.

  This method should not be used by page or tag library authors.

### setAttribute

    public abstract void setAttribute(java.lang.String name,
                                      java.lang.Object attribute)

  Register the name and object specified with page scope semantics.

  Parameters:
    `name` - the name of the attribute to set
    `attribute` - the object to associate with the name
  Throws:
    `java.lang.NullPointerException` - if the name or object is null

### setAttribute

    public abstract void setAttribute(java.lang.String name,
                                      java.lang.Object o,
                                      int scope)

  register the name and object specified with appropriate scope semantics

  Parameters:
    `name` - the name of the attribute to set
    `o` - the object to associate with the name
    `scope` - the scope with which to associate the name/object
  Throws:
    `java.lang.NullPointerException` - if the name or object is null
    `java.lang.IllegalArgumentException` - if the scope is invalid

### getAttribute

    public abstract java.lang.Object getAttribute(java.lang.String name)

  Return the object associated with the name in the page scope or null if not found.

  Parameters:
    `name` - the name of the attribute to get
  Throws:
    `java.lang.NullPointerException` - if the name is null
    `java.lang.IllegalArgumentException` - if the scope is invalid

### getAttribute

    public abstract java.lang.Object getAttribute(java.lang.String name,
                                                  int scope)

  Return the object associated with the name in the specified scope or null if not found.

  Parameters:
    `name` - the name of the attribute to set
    `scope` - the scope with which to associate the name/object
  Throws:
    `java.lang.NullPointerException` - if the name is null
    `java.lang.IllegalArgumentException` - if the scope is invalid

### findAttribute

    public abstract java.lang.Object findAttribute(java.lang.String name)

  Searches for the named attribute in page, request, session (if valid), and application scope(s) in order and returns the value associated or null.

  Returns:
    the value associated or null

### removeAttribute

    public abstract void removeAttribute(java.lang.String name)

  Remove the object reference associated with the given name, look in all scopes in the scope order.

  Parameters:
    `name` - The name of the object to remove.

### removeAttribute

    public abstract void removeAttribute(java.lang.String name,
                                         int scope)

  Remove the object reference associated with the specified name in the given scope.

  Parameters:
    `name` - The name of the object to remove.
    `scope` - The scope where to look.

### getAttributesScope

    public abstract int getAttributesScope(java.lang.String name)

  Get the scope where a given attribute is defined.

  Returns:
    the scope of the object associated with the name specified or 0

### getAttributeNamesInScope

    public abstract java.util.Enumeration getAttributeNamesInScope(int scope)

  Enumerate all the attributes in a given scope

  Returns:
    an enumeration of names (java.lang.String) of all the attributes the specified scope

### getOut

    public abstract JspWriter getOut()

  The current value of the out object (a JspWriter).

  Returns:
    the current JspWriter stream being used for client response

### getSession

    public abstract HttpSession getSession()

  The current value of the session object (an HttpSession).

  Returns:
    the HttpSession for this PageContext or null

### getPage

    public abstract java.lang.Object getPage()

  The current value of the page object (a Servlet).

  Returns:
    the Page implementation class instance (Servlet) associated with this PageContext

### getRequest

    public abstract ServletRequest getRequest()

  The current value of the request object (a ServletRequest).

  Returns:
    The ServletRequest for this PageContext

### getResponse

    public abstract ServletResponse getResponse()

  The current value of the response object (a ServletResponse).

  Returns:
    the ServletResponse for this PageContext

### getException

    public abstract java.lang.Exception getException()

  The current value of the exception object (an Exception).

  Returns:
    any exception passed to this as an errorpage

### getServletConfig

    public abstract ServletConfig getServletConfig()

  The ServletConfig instance.

  Returns:
    the ServletConfig for this PageContext

### getServletContext

    public abstract ServletContext getServletContext()

  The ServletContext instance.

  Returns:
    the ServletContext for this PageContext

### forward

    public abstract void forward(java.lang.String relativeUrlPath)
                          throws ServletException,
                                 java.io.IOException

  This method is used to re-direct, or "forward" the current ServletRequest and ServletResponse to another active component in the application.

  If the relativeUrlPath begins with a "/" then the URL specified is calculated relative to the DOCROOT of the `ServletContext` for this JSP. If the path does not begin with a "/" then the URL specified is calculated relative to the URL of the request that was mapped to the calling JSP.

  It is only valid to call this method from a `Thread` executing within a `_jspService(...)` method of a JSP.

  Once this method has been called successfully, it is illegal for the calling `Thread` to attempt to modify the `ServletResponse` object. Any such attempt to do so, shall result in undefined behavior. Typically, callers immediately return from `_jspService(...)` after calling this method.

  Parameters:
    `relativeUrlPath` - specifies the relative URL path to the target resource as described above
  Throws:
    `ServletException`
    `java.io.IOException`
    `java.lang.IllegalArgumentException` - if target resource URL is unresolvable
    `java.lang.IllegalStateException` - if `ServletResponse` is not in a state where a forward can be performed
    `java.lang.SecurityException` - if target resource cannot be accessed by caller

### include

    public abstract void include(java.lang.String relativeUrlPath)
                          throws ServletException,
                                 java.io.IOException

  Causes the resource specified to be processed as part of the current ServletRequest and ServletResponse being processed by the calling Thread. The output of the target resources processing of the request is written directly to the ServletResponse output stream.

  The current JspWriter "out" for this JSP is flushed as a side-effect of this call, prior to processing the include.

  If the relativeUrlPath begins with a "/" then the URL specified is calculated relative to the DOCROOT of the `ServletContext` for this JSP. If the path does not begin with a "/" then the URL specified is calculated relative to the URL of the request that was mapped to the calling JSP.

  It is only valid to call this method from a `Thread` executing within a `_jspService(...)` method of a JSP.

  Parameters:
    `relativeUrlPath` - specifies the relative URL path to the target resource to be included
  Throws:
    `ServletException`
    `java.io.IOException`
    `java.lang.IllegalArgumentException` - if the target resource URL is unresolvable
    `java.lang.SecurityException` - if target resource cannot be accessed by caller

### handlePageException

    public abstract void handlePageException(java.lang.Exception e)
                                      throws ServletException,
                                             java.io.IOException

  This method is intended to process an unhandled "page" level exception by redirecting the exception to either the specified error page for this JSP, or if none was specified, to perform some implementation dependent action.

  A JSP implementation class shall typically clean up any local state prior to invoking this and will return immediately thereafter. It is illegal to generate any output to the client, or to modify any ServletResponse state after invoking this call.

  This method is kept for backwards compatiblity reasons. Newly generated code should use PageContext.handlePageException(Throwable).

  Parameters:
    `e` - the exception to be handled
  Throws:
    `ServletException`
    `java.io.IOException`
    `java.lang.NullPointerException` - if the exception is null
    `java.lang.SecurityException` - if target resource cannot be accessed by caller
  See Also:
    `handlePageException(Throwable)`

### handlePageException

    public abstract void handlePageException(java.lang.Throwable t)
                                      throws ServletException,
                                             java.io.IOException

  This method is identical to the handlePageException(Exception), except that it accepts a Throwable. This is the preferred method to use as it allows proper implementation of the errorpage semantics.

  This method is intended to process an unhandled "page" level exception by redirecting the exception to either the specified error page for this JSP, or if none was specified, to perform some implementation dependent action.

  A JSP implementation class shall typically clean up any local state prior to invoking this and will return immediately thereafter. It is illegal to generate any output to the client, or to modify any ServletResponse state after invoking this call.

  Parameters:
    `t` - the throwable to be handled
  Throws:
    `ServletException`
    `java.io.IOException`
    `java.lang.NullPointerException` - if the exception is null
    `java.lang.SecurityException` - if target resource cannot be accessed by caller
  See Also:
    `handlePageException(Exception)`

### pushBody

    public BodyContent pushBody()

  Return a new BodyContent object, save the current "out" JspWriter, and update the value of the "out" attribute in the page scope attribute namespace of the PageContext

  Returns:
    the new BodyContent

### popBody

    public JspWriter popBody()

  Return the previous JspWriter "out" saved by the matching pushBody(), and update the value of the "out" attribute in the page scope attribute namespace of the PageConxtext

  Returns:
    the saved JspWriter.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2002 The Apache Software Foundation. All Rights Reserved.